"""
CS 1
MP6: Crystal Lattices
Student Name: TODO

TODO: 2-3 sentence program overview.
"""
import math
from atom import Atom


# TODO: Implement this CubicLattice class as described in the spec.
# TODO: Include any docstrings that are omitted in methods
# TODO: Remove all TODOs/pass statements when you finish.
class CubicLattice():
    # TODO: Class docstring

    def __init__(self, lparam, atoms=None, in_filename=None):
        # TODO: B.1. and C.3.
        pass

    def get_lattice_parameter(self):
        # TODO: B.2
        pass

    def get_cell_volume(self):
        # TODO: B.3
        pass

    def get_unique_elements(self):
        # TODO: B.4
        pass

    def get_number_atoms(self):
        # TODO: B.5.
        pass

    def get_inverted_cell(self):
        # TODO: B.6.
        pass

    def as_xyz(self, crystal_name):
        """
        Returns a string representation of the crystal given
        a specified `crystal_name` that is in standard .xyz file format.

        An XYZ file format is strictly as follows (guaranteeing each
        Atom_I_Element line to be comprised of 4 components):

        # of atoms N
        Name of the crystal (basically a comment)
        Atom_1_Element Atom_1_X Atom_1_Y Atom_1_Z
        Atom_2_Element Atom_2_X Atom_2_X Atom_2_Z
        ...
        Atom_N_Element Atom_N_X Atom_N_Y Atom_N_Z

        For example (16 lines total):
        14
        Aluminum FCC
        Al 0.0 0.0 0.0
        ...
        Al 2.0 2.0 4.0

        Arguments:
            - crystal_name (str): Name of crystal to specify (the second
              line in .xyz format)

        Returns:
            - (str) .xyz data format of crystal, with each line ending with
              '\n' (including the last)
        """
        # TODO: C.1.

    def write_to_xyz(self, crystal_name, out_filename):
        """
        Writes the current crystal to an XYZ file, which is a standard
        file format compatible with 3D crystal-viewing software.
        See `CubicLattice.as_xyz` for more information on the XYZ
        representation.

        Note: Overwrites file if one already exists.

        Arguments:
            - crystal_name (str): Crystal name; the second line in .xyz file.
            - out_filename (str): Filename to write to (should end in .xyz)

        Returns:
            - None (crystal data is written to `out_filename`)
        """
        # TODO: C.2.

    def get_atoms_from_xyz(self, in_filename):
        """
        Given an in_filename, returns a list of Atoms created from the file
        specifications, which should be in valid .xyz format.
        See `CubicLattice.as_xyz` for a summary of a valid XYZ format.

        Note that the (x, y, z) coordinates specified by each XYZ Atom line
        are converted to floats for the list of constructed Atoms.

        Raises:
            - FileNotFoundError if `in_filename` doesn't exist
        """
        # TODO: C.3. (reminder, you aren't raising any FileNotFoundError,
        # this is just noted to a client so they know we don't handle this
        # specially)
        pass


# ----------------------------------------
# END CubicLattice class definition
# ----------------------------------------
# 3 helper _functions_ for lattice coordinates; note that these
# generalize for any 3D cube representation, not just 3D crystal lattices.
# DO NOT CHANGE these three functions.
def is_corner(coordinates, length):
    """
    Returns whether the given coordinates are on a corner of a cube with
    side length `length`.

    Arguments:
        - coordinates (tup/list): (x, y, z) coordinates to test
        - length (int/float): side length of cube

    Returns:
        - (bool): True iff passed coordinates match corners of `length`^3 cube

    Raises:
        - ValueError if the passed coordinates does not have exactly 3 values.
    """
    if len(coordinates) != 3:
        raise ValueError('coordinates must be a 3-element tuple.')

    for coord in coordinates:
        # By definition, each x, y, z value in a coordinate must be 0 or
        # the length of the cube
        if coord != 0 and coord != length:
            return False
    return True


def is_cell_center(coordinates, length):
    """
    Returns whether the given coordinates are at the center of a
    cube with side length `length`.

    Arguments:
        - coordinates (tup/list): (x, y, z) coordinates to test
        - length (int/float): side length of cube

    Returns:
        - (bool): True iff coordinates are the center of `length`^3 cube

    Raises:
        - ValueError if the passed coordinates does not have exactly 3 values.
    """
    if len(coordinates) != 3:
        raise ValueError('coordinates must be a 3-element tuple.')

    for coord in coordinates:
        # By definition, each x, y, z value in a coordinate must be length/2
        # if it is the cube's center
        if coord != length / 2:
            return False
    return True


def is_face_center(coordinates, length):
    """
    Returns whether the given coordinates are on the center of a cube's _face_
    with side length `length`. In other words, they are not at one of the 8
    corners or the center of the cube.

    Arguments:
        - coordinates (tup/list): (x, y, z) coordinates to test
        - length (int/float): side length of cube

    Returns:
        - (bool): True iff coordinates are at the center of any of the 6
                  faces of a `length`^3 cube

    Raises:
        - ValueError if the passed coordinates does not have exactly 3 values.
    """
    if len(coordinates) != 3:
        raise ValueError('coordinates must be a 3-element tuple.')

    # By definition, coordinates must not be a corner or the center of the cube
    return not (is_corner(coordinates, length) or
                is_cell_center(coordinates, length))
